#include "../framelib.c"
/* Testing the butterfly skeleton */

#define THINGS 3

int *a;

void level (void)
{
  int length = THINGS;

  if (myrank() < mycommsize()/2) {
    a = Take(&length);
  } else {
    Give (a, THINGS);
  }
}

int main (int argc, char *argv[])
{
  int i, p, dims;
  double mpi_start, mpi_end;

  MPI_Init(&argc, &argv);
  SkelLibInit();
  p = mycommsize();
  dims = 0; i = p;
  while (i>1) { dims++; i/=2;}

  a = (int *) malloc (THINGS *sizeof(int));
  for (i=0; i<THINGS; i++) a[i] = myrank();

  mpi_start = MPI_Wtime();
  Butterfly (dims, level, MPI_INT, mycomm());
  mpi_end = MPI_Wtime();

  for (p=0; p<mycommsize(); p++) {
    MPI_Barrier (mycomm());
    if (myrank() == p) {
      printf("P%d has ",myrank());
      for (i=0; i<THINGS; i++) {
          printf("%d ", a[i]);
      }
      printf("\n");
    }
  }

  MPI_Barrier (mycomm());
  fflush(stdout);
  printf("P%d ran the butterfly in %.2f seconds\n", myrank(), mpi_end-mpi_start);
  fflush(stdout);

  MPI_Finalize();
}
