#include "../eSkel.c"

#define P 3

eSkel_atom_t *addthree (eSkel_atom_t *datum) {

  int *data = (int *)(datum->data);

  data[0] += 3;
  return datum;

}

eSkel_atom_t *subtracttwo (eSkel_atom_t *datum) {

  int *data = (int *)(datum->data);

  data[0] -= 2;
  return datum;

}

eSkel_atom_t *treble(eSkel_atom_t *datum) {

  int *data = (int *)(datum->data);

  printf("Final stage will return %d\n", data[0]*3);
  data[0] *= 3;
  return datum;

}

int main (int argc, char *argv[]) {
  int *inputs;
  int *results;
  int i, outmul;
  spread_t spreads[P+1];
  MPI_Datatype types[P+1];
  eSkel_atom_t *(*stages[P])(eSkel_atom_t *);

  MPI_Init(&argc, &argv);
  SkelLibInit();

  inputs  = (int *) malloc (sizeof(int)*2);
  results = (int *) malloc (sizeof(int)*2);
  for (i=0; i<2; i++) {
    inputs[i]  = myrank()*2+i+1;
  }

  stages[0] = addthree; stages[1] = subtracttwo; stages[2] = treble;

  for (i=0; i<P+1; i++) {
    spreads[i] = SPLOCAL;
    types[i]   = MPI_INT;
  }

  Pipeline1for1 (P, stages, myrank(), spreads, types, (void *) inputs, 1, 2,
                 (void *) results, 1, &outmul, 2, mycomm());

  MPI_Finalize();
  return 0;
}
