#include "../eSkel.c"
#define P 4 
#define MULT 5
#define N (MULT*P)
int tasksdone=0;

int *tasks;
int *ulam;
int *allulam;

double mpi_start, mpi_end;

eSkel_atom_t *work (eSkel_atom_t *task)
{
  int n, iters;

  n = ((int *) (task->data))[0];
  iters = 0;
  while (n>1) {
    if (n%2) n=3*n+1;
    else n=n/2;
    iters++;
  }
  ((int *) (task->data))[0] = iters;
  tasksdone++;
  return task;
}

int main (int argc, char *argv[])
{
  int i;
  int outmul; 

  MPI_Init(&argc, &argv);
  SkelLibInit();

  tasks  = (int *) malloc (sizeof(int)*MULT);
  ulam   = (int *) malloc (sizeof(int)*MULT);
  for (i=0; i<MULT; i++) {
    tasks[i] = myrank()*MULT + i + 1;
  }

  mpi_start = MPI_Wtime();
  SimpleFarm1for1 (work, (void *) tasks, 1, MULT, SPLOCAL, MPI_INT,
                   (void *) ulam, 1, &outmul, SPLOCAL, MPI_INT, MULT, mycomm());
  mpi_end = MPI_Wtime();

  if (myrank() == 0) {
    allulam = (int *) malloc (sizeof(int)*N);
  }
 
  MPI_Gather (ulam, MULT, MPI_INT, allulam, MULT, MPI_INT, 0, MPI_COMM_WORLD);
 
  if (myrank() == 0) {
    printf("\nUlam values: ");
    for (i=0; i<N; i++) {
      printf ("%d ", allulam[i]);
    }
    printf("\n");
  }

  printf("P%d ran %d task(s) in %.2f seconds\n", myrank(), tasksdone, mpi_end-mpi_start);
  MPI_Finalize();
  return 0;
}
