void Butterfly (int nd, void level(), MPI_Datatype ty, MPI_Comm comm)
{
  int i, dim, two2nd;
  MPI_Comm tempcomm;

  Top++;
  /* Some of this copying is probably redundant */
  FrStack[Top] = (skel_t *) malloc (sizeof(skel_t));
  FrStack[Top]->skel         = Bskel;
  FrStack[Top]->context.b.nd = nd;

  MPI_Comm_dup(comm, &(FrStack[Top]->mycomm));
  MPI_Comm_rank(FrStack[Top]->mycomm, &FrStack[Top]->myrank);
  MPI_Comm_size(FrStack[Top]->mycomm, &FrStack[Top]->mycommsize);
  FrStack[Top]->context.b.mypartnerrank = (myrank() + (mycommsize()/2))%mycommsize();

  for (two2nd = 1, i = 1; i<=nd; i++) two2nd *=2;
  if (FrStack[Top]->mycommsize != two2nd) {
    fprintf(stderr, "Butterfly called with inappropriate number of processes\n");
    exit(0);
  }

  FrStack[Top]->context.b.ty = ty;   
  MPI_Type_size(ty, &FrStack[Top]->context.b.itemsz);

  for (dim = nd; dim>0; dim--) {
    level();  
    if (dim>1) {
      MPI_Comm_split(FrStack[Top]->mycomm, (FrStack[Top]->myrank)<(FrStack[Top]->mycommsize/2), 0, &tempcomm);
      FrStack[Top]->mycomm = tempcomm;
      MPI_Comm_rank(FrStack[Top]->mycomm, &FrStack[Top]->myrank);
      MPI_Comm_size(FrStack[Top]->mycomm, &FrStack[Top]->mycommsize);
      FrStack[Top]->context.b.mypartnerrank = (myrank() + (mycommsize()/2))%mycommsize();
    }
  }
  Top--;
}
