/* A macro in the real version */
int myrank (void)
{
  return FrStack[Top]->myrank;
}

/* A macro in the real version */
int mycommsize (void)
{
  return FrStack[Top]->mycommsize;
}

/* A macro in the real version */
MPI_Comm mycomm (void)
{
  return FrStack[Top]->mycomm;
}

void SkelLibInit (void)
/*  Assumes that MPI has already been initialized */
{
  Top = 0;
  FrStack[Top] = (skel_t *) malloc (sizeof(skel_t));
  FrStack[Top]->skel = NOskel;
  FrStack[Top]->mycomm = MPI_COMM_WORLD;
  MPI_Comm_rank(FrStack[Top]->mycomm, &FrStack[Top]->myrank);
  MPI_Comm_size(FrStack[Top]->mycomm, &FrStack[Top]->mycommsize);
  MPI_Type_size(MPI_INT, &mpiintsize);

  return;
}

void Give (void *out, int len)
{
  if (FrStack[Top]->skel == Fskel) {
    FarmGive(out, len);  
  } else if (FrStack[Top]->skel == Pskel) {
    PipeGive(out, len);  
  } else if (FrStack[Top]->skel == Bskel) {
    ButterflyGive(out, len);  
  } else if (FrStack[Top]->skel == SFskel) {
    SimpleFarmGive(out, len);  
  } else {
    printf("Trying to Take within unimplemented context....\n");
    exit(0);
  }
  return;
}

void *Take (int *items)
{
   if (FrStack[Top]->skel == Fskel) {
     return FarmTake(items);
   } else if (FrStack[Top]->skel == Pskel) {
     return PipeTake(items);
   } else if (FrStack[Top]->skel == Bskel) {
     return ButterflyTake(items);
   } else if (FrStack[Top]->skel == SFskel) {
     return SimpleFarmTake(items);
   } else {
     printf("Trying to Take within unimplemented context....\n");
     exit(0);
   }
}

void *Exchange (int *inlen, void *out, int outlen) 
{
   if (FrStack[Top]->skel == Bskel) {
     return (void *) ButterflyExchange(inlen, out, outlen);
   } else {
     printf("Trying to Exchange within unimplemented context....\n");
     exit(0);
   }
}
