/* Pipeline1for1 is implemented as a wrapper around the more general Pipeline1for1v. This is not */
/* necessarily optimal.                                                                */
void Pipeline1for1 (int ns, eSkel_atom_t *(*stages[])(eSkel_atom_t *),
                    int col, spread_t spr[], MPI_Datatype ty[],
                    void *in, int inlen, int inmul, void *out, int outlen, int *outmul,
                    int outbuffsz, MPI_Comm comm)
{
  int *inlens;
  int *outlens;
  int i;

  inlens = (int *) malloc (sizeof(int)*inmul);
  for (i=0; i<inmul; i++) {
    inlens[i] = inlen;
  }
  if (outlen && (outbuffsz/outlen > 1)) {
    outlens = (int *) malloc (sizeof(int)* outbuffsz/outlen);
  } else {
    outlens = (int *) malloc (sizeof(int)* 2);
  }
  outlens[0] = outbuffsz;
  outlens[1] = outlen ? outbuffsz/outlen : 0;
  Pipeline1for1v (ns, stages, col, spr, ty, in, inlens, inmul, out, outlens, outmul, comm);
}



