void SimpleFarmGive (void *out, int len)
{
   /* Just stick it in the output buffer for subsequent collection */
   FrStack[Top]->context.sf.outblens[FrStack[Top]->context.sf.outbcount] = len;
   FrStack[Top]->context.sf.outbtags[FrStack[Top]->context.sf.outbcount] = FrStack[Top]->context.sf.currenttag;
   FrStack[Top]->context.sf.outbuff[FrStack[Top]->context.sf.outbcount] = 
     (char *) malloc (len*FrStack[Top]->context.sf.outsz);
   memcpy((void *) FrStack[Top]->context.sf.outbuff[FrStack[Top]->context.sf.outbcount], 
          (char *) out, len*FrStack[Top]->context.sf.outsz);
   FrStack[Top]->context.sf.outbcount++;
}

void *SimpleFarmTake (int *items)
{
   MPI_Status stat;
   int totallen;
   char *takeptr;

   /* intended for the farmer thread on parent proc 0 */
   MPI_Send(NULL, 0, MPI_BYTE, 0, FARMTAKETAG, FrStack[Top]->context.sf.tofarmercomm);
   MPI_Recv(items, 1, MPI_INT, 0, MPI_ANY_TAG, FrStack[Top]->context.sf.fromfarmercomm, &stat);
   if (stat.MPI_TAG==SHUTDOWNTAG) {
     return NULL;
   } else {
     takeptr = (char *) malloc(FrStack[Top]->context.sf.insz* (*items));
     MPI_Recv(takeptr, (*items), FrStack[Top]->context.sf.inty,
              0, MPI_ANY_TAG, FrStack[Top]->context.sf.fromfarmercomm, &stat);
     MPI_Recv(&(FrStack[Top]->context.sf.currenttag), 1, MPI_INT, 0, 
              MPI_ANY_TAG, FrStack[Top]->context.sf.fromfarmercomm, &stat);
     return takeptr;
   }
}


